#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef __linux__
#include <bsd/stdlib.h>
#endif

#include "advent2015.h"
#include "advent2016.h"
#include "advent2017.h"
#include "advent2018.h"
#include "advent2019.h"
#include "advent2020.h"

int main(void) {
	int day, year;
	char buf[32];
	const char *errstr;

	printf("--- Advent of Code ---\n");

	while (1) {
		day = 0;
		year = 0;
		errstr = NULL;

		printf("Enter a year (15-20). Enter 'q' to quit: ");
		scanf("%s", buf);

		if (0 == strcmp(buf, "Q") || 0 == strcmp(buf, "q")) {
			break;
		}

		year = strtonum(buf, 15, 20, &errstr);
		if (NULL != errstr) {
			printf("Input error: %s\n\n", errstr);
			continue;
		}

		printf("Enter a day (1-25): ");
		scanf("%s", buf);
		day = strtonum(buf, 1, 25, &errstr);
		if (NULL != errstr) {
			printf("Input error: %s\n\n", errstr);
			continue;
		}

		printf("\n");

		switch(year) {
		case 15: solutions2015[day-1](); break;
		case 16: solutions2016[day-1](); break;
		case 17: solutions2017[day-1](); break;
		case 18: solutions2018[day-1](); break;
		case 19: solutions2019[day-1](); break;
		case 20: solutions2020[day-1](); break;
		}

		printf("\n");
	}

	return 0;
}
